# Alternative scrollbar styles
You can find other scrollbar styles in here with some screenshots. You should only use 1 at a time, and each time you change the style, you'll have to clear the "startupcache" folder on the local folder inside `about:profiles` for changes to take effect.

## Files outside the colored scrollbar folders

### Scrollbars-minimal.as.css
![Minimal scrollbar](https://i.imgur.com/eWYEmiU.png)

A semi-transparent slim scrollbar with no background. It widens by 1 px when you click it.

## Files inside the colored scrollbar folders

### Scrollbars-default-(color).as.css

These will be the same as the default scrollbar for this theme (the one inside the profile folder in this repository), but in a different color. It won't appear inside the blue scrollbars folder (since that's the default scrollbar that we are making reference to).

### Scrollbars-rail-bg-flat.as.css
![Rail background scrollbars](https://i.imgur.com/EFHFpRk.png)

Grey thumb scrollbar with a semi-transparent white line as background (rail-like). This emulates the [original design](https://gist.github.com/Arty2/fdf19aea2c601032410516f059d58eb1) that Arty2 had for the code of these scrollbars.

### Scrollbars-rail-bg.as.css
Same as the one above, but has gradient colors instead of flat ones for the thumb.

### Scrollbars-squared.as.css
![Default square scrollbars](https://i.imgur.com/JfopQbb.png)

This scrollbar resembles the default firefox one, except it's darkish, and has a gradient background.

### Scrollbars-squared-slim.as.css
Same design than the squared one, but less width (12px instead of 16px).

### Scrollbars-old.as.css
![Old scrollbars](https://i.imgur.com/2WBVmxY.png)

This is the old default scrollbar of this theme. It has flat colors and has a 3 colors gradient as background.

### Scrollbars-flat-colors.as.css
![Flat colors scrollbar](https://i.imgur.com/s668zt7.png)

This one is like the default scrollbar, but has flat colors with a transition effect when hovering over it.

### Scrollbars-slim.as.css
Same design than the default one from this theme, but less width (12px instead of 16px).

### Scrollbars-no-transitions.as.css
Same design as the default one from this theme, but these won't have transitions.

### Scrollbars-shrink.as.css
Same design as the default one from this theme, but this one shrinks when active, instead of getting wider.
